%  Copyright 2010 Carlos Gonzalez-Aguado
%
%  This file is part of the SAMPLE CODE for the following paper:
%  Bruche, M., Gonzalez-Aguado, C. "Recovery Rates, Default Probabilities, and the Credit Cycle"
%  Journal of Banking and Finance 34(4), 2010, 713-723.
%  
%  SAMPLE CODE is free software: you can redistribute it and/or modify it under
%  the terms of the GNU General Public License as published by the Free
%  Software Foundation, either version 3 of the License, or (at your option)
%  any later version.
%  
%  SAMPLE CODE is distributed in the hope that it will be useful, but WITHOUT
%  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
%  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
%  more details.
%  
%  You should have received a copy of the GNU General Public License along with
%  SAMPLE CODE.  If not, see <http://www.gnu.org/licenses/>.


% This routine uses the variables included in the model to construct the default rates data matrix.

% Declare global variables
global dr_mat0 dr_mat1 dr_mat dr_cycle dr_macro macro_var t

% If there is a latent vairable for default rates, the routine will create two matrices, dr_mat0 and dr_mat1. Otherwise, only one matrix, dr_mat will be created. In addition, if macro variables are included in the model, these matrices will have one additional column.
if dr_cycle
    dr_mat1 = ones(t,2+dr_macro);
    dr_mat0 = dr_mat1;
    dr_mat0(:,2) = zeros(t,1);
    if dr_macro
        dr_mat1(:,3) = macro_var;
        dr_mat0(:,3) = macro_var;
    end
else
    dr_mat = ones(t,1+dr_macro);
    if dr_macro
        dr_mat(:,2) = macro_var;
    end
end

    
