%  Copyright 2010 Carlos Gonzalez-Aguado
%
%  This file is part of the SAMPLE CODE for the following paper:
%  Bruche, M., Gonzalez-Aguado, C. "Recovery Rates, Default Probabilities, and the Credit Cycle"
%  Journal of Banking and Finance 34(4), 2010, 713-723.
%  
%  SAMPLE CODE is free software: you can redistribute it and/or modify it under
%  the terms of the GNU General Public License as published by the Free
%  Software Foundation, either version 3 of the License, or (at your option)
%  any later version.
%  
%  SAMPLE CODE is distributed in the hope that it will be useful, but WITHOUT
%  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
%  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
%  more details.
%  
%  You should have received a copy of the GNU General Public License along with
%  SAMPLE CODE.  If not, see <http://www.gnu.org/licenses/>.


% This script returns some reasonable initial conditions for the parameters

function f = get_ini(dcyc,rcyc,dmac,rmac,rind)

% Declare global variables
global pars rr_pars

% Initialization
inivec = ones(1 + dcyc + dmac + 2*(rr_pars),1)*0.6;

% Default rates initial conditions
    inivec(1) = 3;
    % Macro
    if dmac
        inivec(2+dcyc) = 0;
    end

% Recovery rates initial conditions
    % Macro
    if rmac
        inivec(pars(2,2)-2*rind-2:pars(2,2) - 2*rind) = 0;
        inivec(pars(3,2)-2*rind-2:pars(3,2) - 2*rind) = 0;
    end
     
% Probabilities in case of a latent variable
if dcyc | rcyc
    inivec(pars(4,1):pars(4,2)) = [-2;-1;0];
end

% Final return
f = inivec;
