%  Copyright 2010 Carlos Gonzalez-Aguado
%
%  This file is part of the SAMPLE CODE for the following paper:
%  Bruche, M., Gonzalez-Aguado, C. "Recovery Rates, Default Probabilities, and the Credit Cycle"
%  Journal of Banking and Finance 34(4), 2010, 713-723.
%  
%  SAMPLE CODE is free software: you can redistribute it and/or modify it under
%  the terms of the GNU General Public License as published by the Free
%  Software Foundation, either version 3 of the License, or (at your option)
%  any later version.
%  
%  SAMPLE CODE is distributed in the hope that it will be useful, but WITHOUT
%  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
%  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
%  more details.
%  
%  You should have received a copy of the GNU General Public License along with
%  SAMPLE CODE.  If not, see <http://www.gnu.org/licenses/>.



global rr_cycle rr_mat rr_mat0 rr_mat1 pars rr fil

downturn = (year == 1989 | year == 1990 | year==1991 | year ==1999 | year==2000 | year ==2001| year==2002 | year==2003);

if rr_cycle
    a0 = exp(rr_mat0 * x(pars(2,1):pars(2,2)));
    b0 = exp(rr_mat0 * x(pars(3,1):pars(3,2)));
    a1 = exp(rr_mat1 * x(pars(2,1):pars(2,2)));
    b1 = exp(rr_mat1 * x(pars(3,1):pars(3,2)));
    cdf0 = betacdf(rr,a0,b0);
    cdf1 = betacdf(rr,a1,b1);
    % Probabilities
    p = 1 / (1 + exp(x(pars(4,1))));
    q = 1 / (1 + exp(x(pars(4,1)+1)));
    % Smoothed probabilities
    smp = zeros(t,1);
    smp(t) = fil(t);
    for i = t-1 : -1 : 1
        smp(i) = fil(i) * ((1-smp(i+1))*(1-p)/(1 - upd(i+1)) + smp(i+1)*p/upd(i+1));
    end
    smo_obs = zeros(n,1);
    smo_obs = smp(year - 1980);
    % Final
    z = cdf1.*smo_obs + cdf0.*(1-smo_obs);
    z_dw = z(downturn);
    z_up = z(~downturn);
else
    a = exp(rr_mat * x(pars(2,1):pars(2,2)));
    b = exp(rr_mat * x(pars(3,1):pars(3,2)));
    z = betacdf(rr,a,b);
    z_dw = z(downturn);
    z_up = z(~downturn);
end
